
#include <exe2rom.h>

char* exe2rom_convert::message[]={
"End programm OK",
"File not found",
"stop message"
};

void exe2rom_convert::addstruct(exe2rom_8 lb,serviceflag sf){

fladdstruct=true;

Load_Image_Size+=sizeof(service);
service.loadadr=start_load_address;
service.lenfile=Load_Image_Size;
service.ss=header.ss_reg;
service.sp=header.sp_reg;
service.ip=header.ip_reg;
service.cs=header.cs_reg;
service.reserved=ALFSERV_RESERVED;
service.csum=0;
service.lastbyte=lb;

ifstream ifile;
ofstream ofile;

if(sf==serviceinbottom){
ofile.open(ofilename,ios::app|ios::binary);
ofile.seekp(0,ios::end);
ofile.write((exe2rom_8*)&service,sizeof(service));
ofile.close();
}

if(sf==serviceintop){

char name[L_tmpnam];
tmpnam(name);

ofile.open(name,ios::binary);
ifile.open(ofilename,ios::binary);

ifile.seekg(0,ios::end);
exe2rom_32 file_size=ifile.tellg();
ifile.seekg(0);

ofile.write((exe2rom_8*)&service,sizeof(service));

exe2rom_32 i;
exe2rom_8 byte;
for(i=0;i!=file_size;i++){
ifile.read(&byte,sizeof(byte));
ofile.write(&byte,sizeof(byte));
}

ofile.close();
ifile.close();

remove(ofilename);
rename(name,ofilename);
}

ifile.open(ofilename,ios::binary);
exe2rom_32 i;
exe2rom_8 byte;
exe2rom_8 csum1=ALFSERV_STARTCSUM;
for(i=0;i!=Load_Image_Size;i++){
ifile.read(&byte,sizeof(byte));
csum1+=byte;
}

ifile.close();

service.csum=csum1;

if(sf==serviceinbottom){
ofile.open(ofilename,ios::ate|ios::binary);
ofile.seekp(Load_Image_Size-sizeof(service));
ofile.write((exe2rom_8*)&service,sizeof(service));
ofile.close();
}

if(sf==serviceintop)   {
ofile.open(ofilename,ios::ate|ios::binary);
ofile.seekp(0);
ofile.write((exe2rom_8*)&service,sizeof(service));
ofile.close();
}
}//addstruct

void exe2rom_convert::convert(){

ifstream ifile(ifilename,ios::binary|ios::nocreate);
ofstream ofile(ofilename,ios::binary);

if(ifile.fail()!=0){
clerr<exe2rom_16> err(&exe2rom_convert::message,EXE2ROM_ERR1);
throw err;
}

ifile.seekg(0,ios::end);
DOS_File_Size=ifile.tellg();
ifile.seekg(0);

//read header
ifile.read((exe2rom_8*)&header,sizeof(header));

len_header_in_byte=header.len_header_in_para<<4;
Load_Image_Size=
header.num_page*exe2rom_lenpage-len_header_in_byte;

if(header.len_lastpage!=0) Load_Image_Size-=exe2rom_lenpage-header.len_lastpage;

ifile.seekg(len_header_in_byte);

//copy
exe2rom_32 i;
exe2rom_8 byte;
for(i=0;i!=Load_Image_Size;i++){
ifile.read(&byte,sizeof(byte));
ofile.write(&byte,sizeof(byte));
}

//correction
ofile.close();

fstream file(ofilename,ios::in|ios::out|ios::binary);

ifile.seekg(header.table_offset);

exe2rom_16 j;
exe2rom_record_in_table_relocation rec;
exe2rom_16 word;
exe2rom_16 startadr=(exe2rom_16)(start_load_address>>4);
for(j=0;j!=header.num_record_in_table_relocation;j++){
ifile.read((exe2rom_8*)&rec,sizeof(rec));

exe2rom_32 addr=rec.segment;
addr=(addr<<4)+rec.offset;

file.seekg(addr);
file.read((exe2rom_8*)&word,sizeof(word));

word+=startadr;

file.seekp(addr);
file.write((exe2rom_8*)&word,sizeof(word));
}//for

}//convert

void exe2rom_convert::fill(exe2rom_32 len,exe2rom_8 val){
if(len>Load_Image_Size){
ofstream ofile(ofilename,ios::app|ios::binary);
ofile.seekp(0,ios::end);
exe2rom_32 i;
exe2rom_32 len1=len-Load_Image_Size;
for(i=0;i!=len1;i++){
ofile.write(&val,sizeof(val));
}//for
}//if
}//fill

template <class T> void exe2rom_p(ofstream& rfile,char* s,T value){
rfile<<s<<hex<<"0x"<<value<<" ("<<dec<<value<<".)";
};

void exe2rom_convert::report(int argc, char *argv[],const char* rfilename){
if(rfilename!=NULL){

ofstream rfile(rfilename);
rfile<<"\n";
about(rfile);
rfile<<"\nDisplay of File "<<ifilename;
rfile<<"\nCommand line";

int i;
for(i=1;i!=argc;i++){
rfile<<" "<<argv[i];
}

rfile<<"\n";

exe2rom_p(rfile,"\nSignature0                                 ",header.signature0);
exe2rom_p(rfile,"\nLength last page                           ",header.len_lastpage);
exe2rom_p(rfile,"\nNumber of page (512 byte)                  ",header.num_page);
exe2rom_p(rfile,"\nRelocation Table entry count               ",header.num_record_in_table_relocation);
exe2rom_p(rfile,"\nSize of header record (in paragraphs)      ",header.len_header_in_para);
exe2rom_p(rfile,"\nMinimum Memory Requirement (in paragraphs) ",header.min_par);
exe2rom_p(rfile,"\nMaximum Memory Requirement (in paragraphs) ",header.max_par);
exe2rom_p(rfile,"\nSS                                         ",header.ss_reg);
exe2rom_p(rfile,"\nSP                                         ",header.sp_reg);
exe2rom_p(rfile,"\nFile load checksum                         ",header.csum);
exe2rom_p(rfile,"\nIP                                         ",header.ip_reg);
exe2rom_p(rfile,"\nCS                                         ",header.cs_reg);
exe2rom_p(rfile,"\nRelocation Table address                   ",header.table_offset);
exe2rom_p(rfile,"\nOverlay Number                             ",header.overlaynumber);
exe2rom_p(rfile,"\nSignature1                                 ",header.signature1);
exe2rom_p(rfile,"\nSignature2                                 ",(unsigned int)header.signature2);
exe2rom_p(rfile,"\nSignature3                                 ",(unsigned int)header.signature3);
exe2rom_p(rfile,"\nSignature4                                 ",header.signature4);

rfile<<"\n";

exe2rom_p(rfile,"\nDOS File Size                              ",DOS_File_Size);
exe2rom_p(rfile,"\nLoad Image Size                            ",Load_Image_Size);

exe2rom_p(rfile,"\nLoad address                               ",start_load_address);


if(fladdstruct==true){
rfile<<"\n";
rfile<<"\nService structure:";
rfile<<"\n";

exe2rom_p(rfile,"\nLoad address in service structure          ",service.loadadr);
exe2rom_p(rfile,"\nLength of file in service structure        ",service.lenfile);
exe2rom_p(rfile,"\nSS in service structure                    ",service.ss);
exe2rom_p(rfile,"\nSP in service structure                    ",service.sp);
exe2rom_p(rfile,"\nIP in service structure                    ",service.ip);
exe2rom_p(rfile,"\nCS in service structure                    ",service.cs);
exe2rom_p(rfile,"\nReserved field in service structure        ",service.reserved);
exe2rom_p(rfile,"\nALF file checksum in service structure     ",(unsigned int)service.csum);
exe2rom_p(rfile,"\nLast byte in service structure             ",(unsigned int)service.lastbyte);
}
else{

rfile<<"\n";
rfile<<"\nIs not service structure in this file";
rfile<<"\n";

}

rfile<<"\n";

}//if
}


