
#ifndef EXE2ROM_THIS
#define EXE2ROM_THIS

#include <fstream.h>
#include <iostream.h>
#include <comline.h>
#include <alfserv.h>
#include <clerr.h>
#include <stdio.h>

#define EXE2ROM_BASEERR (0)

#define EXE2ROM_ERR0 (EXE2ROM_BASEERR+0)
#define EXE2ROM_ERR1 (EXE2ROM_BASEERR+1)
#define EXE2ROM_ERR2 (EXE2ROM_BASEERR+2)
#define EXE2ROM_ERR3 (EXE2ROM_BASEERR+3)
#define EXE2ROM_ERR4 (EXE2ROM_BASEERR+4)
#define EXE2ROM_ERR5 (EXE2ROM_BASEERR+5)
#define EXE2ROM_ERR6 (EXE2ROM_BASEERR+6)
#define EXE2ROM_ERR7 (EXE2ROM_BASEERR+7)
#define EXE2ROM_ERR8 (EXE2ROM_BASEERR+8)
#define EXE2ROM_ERR9 (EXE2ROM_BASEERR+9)

typedef unsigned int       exe2rom_32;
typedef unsigned short int exe2rom_16;
typedef unsigned char      exe2rom_8;

const exe2rom_32 exe2rom_lenpage=512;

struct exe2rom_header{
exe2rom_16 signature0;
exe2rom_16 len_lastpage;
exe2rom_16 num_page;
exe2rom_16 num_record_in_table_relocation;
exe2rom_16 len_header_in_para;
exe2rom_16 min_par;
exe2rom_16 max_par;
exe2rom_16 ss_reg;
exe2rom_16 sp_reg;
exe2rom_16 csum;
exe2rom_16 ip_reg;
exe2rom_16 cs_reg;
exe2rom_16 table_offset;
exe2rom_16 overlaynumber;
exe2rom_16 signature1;
exe2rom_8 signature2;
exe2rom_8 signature3;
exe2rom_16 signature4;
};

struct exe2rom_record_in_table_relocation{
exe2rom_16 offset;
exe2rom_16 segment;
};

class exe2rom_convert{
exe2rom_header header;
exe2rom_32 DOS_File_Size;
exe2rom_32 Load_Image_Size;
exe2rom_32 len_header_in_byte;
char* ifilename;
char* ofilename;
exe2rom_32 start_load_address;
alfserv<exe2rom_32,exe2rom_16,exe2rom_8> service;
bool fladdstruct;

public:

enum serviceflag {serviceintop,serviceinbottom};

static char* message[];
exe2rom_convert(){DOS_File_Size=0;Load_Image_Size=0;}
void init(exe2rom_32 sadr,const char* ifilen,const char* ofilen){
start_load_address=sadr;ofilename=(char*)ofilen;ifilename=(char*)ifilen;
fladdstruct=false;
}
void convert();
void addstruct(exe2rom_8 lb,serviceflag sf);
void fill(exe2rom_32 len,exe2rom_8 val);
void report(int argc, char *argv[],const char* rfilename);
void about(ostream& os){
os<<"\nConvert from DOS *.exe format to ROMable format";
os<<"\n\
Create by MKTMK. Moscow, Russia v1.02 14.01.2002 (Last modif. 29.06.2004)";
os<<"\ndistributed under the GNU LGPL";
os<<"\nhttp://mktmk.narod.ru";
}
~exe2rom_convert(){}
};

#endif

