
#include <exe2rom.h>
#include <dir.h>

void exe2rom_help(){
cout<<"\n";
cout<<"\nexe2rom [-sw1 -sw2 ... -swn] input_filename [output_filename] [report_filename]";
cout<<"\n";
cout<<"\nSwitch are:";
cout<<"\n-sXXXXX - start address at hex (default 0x00000)";
cout<<"\n-lXXXXX - length of file at hex ";
cout<<"\n-aXX    - fill value at hex (default 0x00)";
cout<<"\n-t      - add service structure in bottom of file";
cout<<"\n-f      - add service structure in top of file";
cout<<"\n-bXX    - last byte in service structure at hex (default 0x01)";
cout<<"\n";
}

int main(int argc, char *argv[]){

try{

exe2rom_convert conv;

exe2rom_32 sa1;
if(comline_getswvalue(argc,argv,'s',&sa1)==false) sa1=0;

char* ifl;
char* ofl;
char drive[MAXDRIVE];
char dir[MAXDIR];
char file[MAXFILE];
char ext[MAXEXT];
char s[MAXPATH];

if(comline_getnswstring(argc,argv,0,&ifl)==false){
conv.about(cout);
exe2rom_help();return EXE2ROM_ERR0;
}

if(comline_getnswstring(argc,argv,1,&ofl)==false){
fnsplit(ifl,drive,dir,file,ext);
fnmerge(s,drive,dir,file,"rom");
ofl=s;
}

conv.init(sa1,ifl,ofl);
conv.convert();

//add service structure
exe2rom_8 lb;
if(comline_getswvalue(argc,argv,'b',&lb)==false) lb=ALFSERV_DEFLASTBYTE;

//add service structure
if(comline_getswvalue(argc,argv,'f',(char*)NULL)==true){
conv.addstruct(lb,exe2rom_convert::serviceintop);
}
else
if(comline_getswvalue(argc,argv,'t',(char*)NULL)==true){
conv.addstruct(lb,exe2rom_convert::serviceinbottom);
}

char* rfl;
if(comline_getnswstring(argc,argv,2,&rfl)==true) conv.report(argc,argv,rfl);

exe2rom_32 len;
exe2rom_8 val=0;

if(comline_getswvalue(argc,argv,'l',&len)==true){
comline_getswvalue(argc,argv,'a',&val);
conv.fill(len,val);
}
}//try

catch(clerr<exe2rom_16> err){
cout<<"\n"<<err.getmessage();
return err.getcodeerr();
}

return EXE2ROM_ERR0;
}

